net.i2p.sam

## Class SSLSocketChannel

- java.lang.Object
- - java.nio.channels.spi.AbstractInterruptibleChannel
  - - java.nio.channels.SelectableChannel
    - - java.nio.channels.spi.AbstractSelectableChannel
      - - java.nio.channels.SocketChannel
        - - net.i2p.sam.SSLSocketChannel

- All Implemented Interfaces:
    Closeable, AutoCloseable, ByteChannel, Channel, GatheringByteChannel, InterruptibleChannel, NetworkChannel, ReadableByteChannel, ScatteringByteChannel, WritableByteChannel

      class SSLSocketChannel
      extends SocketChannel

  Simple wrapper for a SSLSocket. Cannot be used for asynch ops.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SSLSocketChannel(SSLSocket socket)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `SocketChannel` | `bind(SocketAddress local)` requires Java 7
    `boolean` | `connect(SocketAddress remote)`
    `boolean` | `finishConnect()`
    `SocketAddress` | `getLocalAddress()`
    `<T> T` | `getOption(SocketOption<T> name)`
    `SocketAddress` | `getRemoteAddress()` new in Java 7
    `void` | `implCloseSelectableChannel()`
    `void` | `implConfigureBlocking(boolean block)`
    `boolean` | `isConnected()`
    `boolean` | `isConnectionPending()`
    `int` | `read(ByteBuffer src)`
    `long` | `read(ByteBuffer[] srcs, int offset, int length)`
    `<T> SocketChannel` | `setOption(SocketOption<T> name, T value)` requires Java 7
    `SocketChannel` | `shutdownInput()` new in Java 7
    `SocketChannel` | `shutdownOutput()` new in Java 7
    `Socket` | `socket()`
    `Set<SocketOption<?>>` | `supportedOptions()`
    `int` | `write(ByteBuffer src)`
    `long` | `write(ByteBuffer[] srcs, int offset, int length)`

    - ### Methods inherited from class java.nio.channels.SocketChannel

      `open, open, read, validOps, write`

    - ### Methods inherited from class java.nio.channels.spi.AbstractSelectableChannel

      `blockingLock, configureBlocking, implCloseChannel, isBlocking, isRegistered, keyFor, provider, register`

    - ### Methods inherited from class java.nio.channels.SelectableChannel

      `register`

    - ### Methods inherited from class java.nio.channels.spi.AbstractInterruptibleChannel

      `begin, close, end, isOpen`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.nio.channels.Channel

      `close, isOpen`

- - ### Constructor Detail

    - #### SSLSocketChannel

          public SSLSocketChannel(SSLSocket socket)

  - ### Method Detail

    - #### bind

          public SocketChannel bind(SocketAddress local)

      requires Java 7
      Specified by:
        `bind` in interface `NetworkChannel`
      Overrides:
        `bind` in class `SocketChannel`

    - #### connect

          public boolean connect(SocketAddress remote)

      Specified by:
        `connect` in class `SocketChannel`

    - #### finishConnect

          public boolean finishConnect()

      Specified by:
        `finishConnect` in class `SocketChannel`

    - #### getLocalAddress

          public SocketAddress getLocalAddress()

      Specified by:
        `getLocalAddress` in interface `NetworkChannel`
      Specified by:
        `getLocalAddress` in class `SocketChannel`

    - #### getOption

          public <T> T getOption(SocketOption<T> name)

    - #### getRemoteAddress

          public SocketAddress getRemoteAddress()

      new in Java 7
      Specified by:
        `getRemoteAddress` in class `SocketChannel`

    - #### implCloseSelectableChannel

          public void implCloseSelectableChannel()
                                          throws IOException

      Specified by:
        `implCloseSelectableChannel` in class `AbstractSelectableChannel`
      Throws:
        `IOException`

    - #### implConfigureBlocking

          public void implConfigureBlocking(boolean block)
                                     throws IOException

      Specified by:
        `implConfigureBlocking` in class `AbstractSelectableChannel`
      Throws:
        `IOException`

    - #### isConnected

          public boolean isConnected()

      Specified by:
        `isConnected` in class `SocketChannel`

    - #### isConnectionPending

          public boolean isConnectionPending()

      Specified by:
        `isConnectionPending` in class `SocketChannel`

    - #### read

          public int read(ByteBuffer src)
                   throws IOException

      Specified by:
        `read` in interface `ReadableByteChannel`
      Specified by:
        `read` in class `SocketChannel`
      Throws:
        `IOException`

    - #### read

          public long read(ByteBuffer[] srcs,
                           int offset,
                           int length)

      Specified by:
        `read` in interface `ScatteringByteChannel`
      Specified by:
        `read` in class `SocketChannel`

    - #### setOption

          public <T> SocketChannel setOption(SocketOption<T> name,
                                             T value)

      requires Java 7
      Specified by:
        `setOption` in interface `NetworkChannel`
      Specified by:
        `setOption` in class `SocketChannel`

    - #### shutdownInput

          public SocketChannel shutdownInput()
                                      throws IOException

      new in Java 7
      Specified by:
        `shutdownInput` in class `SocketChannel`
      Throws:
        `IOException`

    - #### shutdownOutput

          public SocketChannel shutdownOutput()
                                       throws IOException

      new in Java 7
      Specified by:
        `shutdownOutput` in class `SocketChannel`
      Throws:
        `IOException`

    - #### socket

          public Socket socket()

      Specified by:
        `socket` in class `SocketChannel`

    - #### supportedOptions

          public Set<SocketOption<?>> supportedOptions()

    - #### write

          public int write(ByteBuffer src)
                    throws IOException

      Specified by:
        `write` in interface `WritableByteChannel`
      Specified by:
        `write` in class `SocketChannel`
      Throws:
        `IOException`

    - #### write

          public long write(ByteBuffer[] srcs,
                            int offset,
                            int length)

      Specified by:
        `write` in interface `GatheringByteChannel`
      Specified by:
        `write` in class `SocketChannel`